<?php
class CmsController extends CmsControllerCore
{

  public function getPage() {
    if(isset($_GET['page'])) return $_GET['page'];
    $url = $_SERVER['REQUEST_URI'];
    preg_match_all('/page\/([0-9])*/', $url, $match);
    if(isset($match[1][0])) return $match[1][0];
    return 1;
  } 
  public function getPagerIni($num_pages, $num_display = 10) {
    $page = $this->getPage();
    if($page <= ($num_display/2)) return 1;
    if($num_pages <= $num_display) return 1;
    return $page - intval($num_display/2);
  }
  public function getPagerEnd($num_pages, $num_display = 10) {
    if($num_pages <= $num_display) return $num_pages;
    return $this->getPagerIni($num_displa) - 1 + $num_display;
  }

	public function canonicalRedirection()
	{
		// Automatically redirect to the canonical URL if the current in is the right one
		// $_SERVER['HTTP_HOST'] must be replaced by the real canonical domain

		if (Configuration::get('PS_CANONICAL_REDIRECT') && strtoupper($_SERVER['REQUEST_METHOD']) == 'GET')
		{
			if (Validate::isLoadedObject($this->cms) AND $canonicalURL = self::$link->getCMSLink($this->cms))
				if (!preg_match('/^'.Tools::pRegexp($canonicalURL, '/').'([&?].*)?$/', Tools::getProtocol().$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']))
				{
					header('HTTP/1.0 301 Moved');
					header('Cache-Control: no-cache');
					if (_PS_MODE_DEV_)
						die('[Debug] This page has moved<br />Please use the following URL instead: <a href="'.$canonicalURL.'">'.$canonicalURL.'</a>');
					Tools::redirectLink($canonicalURL);
				}
      $page = $this->getPage();
			if (Validate::isLoadedObject($this->cms_category) AND $canonicalURL = self::$link->getCMSCategoryLink($this->cms_category, null, null, $page))
				if (!preg_match('/^'.Tools::pRegexp($canonicalURL, '/').'([&?].*)?$/', Tools::getProtocol().$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']))
				{
					header('HTTP/1.0 301 Moved');
					header('Cache-Control: no-cache');
					if (_PS_MODE_DEV_ )
						die('[Debug] This page has moved<br />Please use the following URL instead: <a href="'.$canonicalURL.'">'.$canonicalURL.'</a>');
					Tools::redirectLink($canonicalURL);
				}
		}
	}


	public function process()
	{

	//	parent::process();
		$parent_cat = new CMSCategory(1, (int)(self::$cookie->id_lang));
		self::$smarty->assign('id_current_lang', self::$cookie->id_lang);
		self::$smarty->assign('home_title', $parent_cat->name);
		self::$smarty->assign('cgv_id', Configuration::get('PS_CONDITIONS_CMS_ID'));
		if ($this->assignCase == 1)
		{
      if($this->cms->id_cms_category == 2 || $this->cms->id_cms_category == 3) {
        $cmsCatPages = CMS::getCMSPages((int)(self::$cookie->id_lang), (int)($this->cms->id_cms_category));
        $cmsCat = new CMSCategory($this->cms->id_cms_category, self::$cookie->id_lang);

        $current = 0;
        foreach($cmsCatPages as $key => $val) {
          if($this->cms->id == $val['id_cms']) $current = $key;
        }
        $prev = $current-1;
        if($prev < 0) $prev=count($cmsCatPages)-1;
        $next = $current+1;
        if(!isset($cmsCatPages[$next])) $next = 0;
      }
			self::$smarty->assign(array(
				'cms' => $this->cms,
				'content_only' => (int)(Tools::getValue('content_only')),
				'path' => ((isset($this->cms->id_cms_category) AND $this->cms->id_cms_category) ? Tools::getFullPath((int)($this->cms->id_cms_category), $this->cms->meta_title, 'CMS') : Tools::getFullPath(1, $this->cms->meta_title, 'CMS')),
        'cms_cat_pages' => $cmsCatPages,
        'cms_cat' => $cmsCat,
        'cms_next' => $cmsCatPages[$next],
        'cms_prev' => $cmsCatPages[$prev]
			));
		}
		elseif ($this->assignCase == 2)
		{
      $page = $this->getPage();
      $num_pages_display = 9;
      $num_pages = CMS::getCMSPagesNumPages((int)(self::$cookie->id_lang), (int)($this->cms_category->id), true, $num_pages_display);
			self::$smarty->assign(array(
				'category' => $this->cms_category,
				'sub_category' => $this->cms_category->getSubCategories((int)(self::$cookie->id_lang)),
				'cms_pages' => CMS::getCMSPages((int)(self::$cookie->id_lang), (int)($this->cms_category->id), true, $num_pages_display, $page ),
        'pager_num_pages' => $num_pages, 
        'pager_page' => $page,
        'pager_ini' => $this->getPagerIni($num_pages, 10),
        'pager_end' => $this->getPagerEnd($num_pages, 10),
				'path' => ($this->cms_category->id !== 1) ? Tools::getPath((int)($this->cms_category->id), $this->cms_category->name, false, 'CMS') : '',
			));
		}
	}
  public function setMedia() {
    parent::setMedia();
    Tools::addJS(_THEME_JS_DIR_.'cmsslide.js');
	}
}
