<?php

class OrderController extends OrderControllerCore
{

  public function process() {
    parent::process();
    self::$smarty->assign('cartSize', Image::getSize('cart'));
    if($this->step <= 0) {
      $prods = self::$smarty->get_template_vars('products');
      $subCategories = array();
      if($prods) {
        foreach($prods as $prod) {
          if(!isset($subCategories[$prod['id_category_default']])) {
            $cat = new Category($prod['id_category_default'], self::$cookie->id_lang);
            $subcat['products'] =  $cat->getProducts(self::$cookie->id_lang, 1, 1000);
            $subcat['name'] = $cat->name;
            $subCategories[$prod['id_category_default']] = $subcat;
          }
        }
      }
      self::$smarty->assign('subCategories', $subCategories);
    }  
  }

	/*
	 * Manage address
	 */
	public function processAddress()
	{
		if (!Tools::isSubmit('id_address_delivery') OR !Address::isCountryActiveById((int)Tools::getValue('id_address_delivery')))
			$this->errors[] = Tools::displayError('This address is not in a valid area.');
		else
		{
			self::$cart->id_address_delivery = (int)(Tools::getValue('id_address_delivery'));
			self::$cart->id_address_invoice = Tools::isSubmit('same') ? self::$cart->id_address_delivery : (int)(Tools::getValue('id_address_invoice'));
			if (!self::$cart->update())
				$this->errors[] = Tools::displayError('An error occurred while updating your cart.');
      //xavi hack
      if(Tools::isSubmit('wantsbill')) {
        $preMessage = "EL CLIENTE QUIERE RECIBIR LA FACTURA\n\n";
      }
      //end xavi

			if (Tools::isSubmit('message'))
				$this->_updateMessage($preMessage . Tools::getValue('message'));
		}
		if (sizeof($this->errors))
		{
			if (Tools::getValue('ajax'))
				die('{"hasError" : true, "errors" : ["'.implode('\',\'', $this->errors).'"]}');
			$this->step = 1;
		}
		if (Tools::getValue('ajax'))
			die(true);
	}


}

?>
