<?php

class ParentOrderController extends ParentOrderControllerCore {
  protected function _assignAddress()
	{
		//if guest checkout disabled and flag is_guest  in cookies is actived
		if (Configuration::get('PS_GUEST_CHECKOUT_ENABLED') == 0 AND ((int) self::$cookie->is_guest != Configuration::get('PS_GUEST_CHECKOUT_ENABLED')))
		{
			self::$cookie->logout();
			Tools::redirect('');
		}
		elseif (!Customer::getAddressesTotalById((int)(self::$cookie->id_customer)))
			Tools::redirect('address.php?back=order.php?step=1');
		$customer = new Customer((int)(self::$cookie->id_customer));
		if (Validate::isLoadedObject($customer))
		{
			/* Getting customer addresses */
			$customerAddresses = $customer->getAddresses((int)(self::$cookie->id_lang));

			// Getting a list of formated address fields with associated values
			$formatedAddressFieldsValuesList = array();
			foreach($customerAddresses as $address)
			{
				$tmpAddress = new Address($address['id_address']);

				$formatedAddressFieldsValuesList[$address['id_address']]['ordered_fields'] = AddressFormat::getOrderedAddressFields($address['id_country']);
				$formatedAddressFieldsValuesList[$address['id_address']]['formated_fields_values'] = AddressFormat::getFormattedAddressFieldsValues(
					$tmpAddress,
					$formatedAddressFieldsValuesList[$address['id_address']]['ordered_fields']);

				unset($tmpAddress);
			}
			self::$smarty->assign(array(
				'addresses' => $customerAddresses,
				'formatedAddressFieldsValuesList' => $formatedAddressFieldsValuesList));

			/* Setting default addresses for cart */
			if ((!isset(self::$cart->id_address_delivery) OR empty(self::$cart->id_address_delivery)) AND sizeof($customerAddresses))
			{
				self::$cart->id_address_delivery = (int)($customerAddresses[0]['id_address']);
				$update = 1;
			}
			if ((!isset(self::$cart->id_address_invoice) OR empty(self::$cart->id_address_invoice)) AND sizeof($customerAddresses))
			{
				self::$cart->id_address_invoice = (int)($customerAddresses[0]['id_address']);
				$update = 1;
			}
			/* Update cart addresses only if needed */
			if (isset($update) AND $update)
				self::$cart->update();

			/* If delivery address is valid in cart, assign it to Smarty */
			if (isset(self::$cart->id_address_delivery))
			{
				$deliveryAddress = new Address((int)(self::$cart->id_address_delivery));
				if (Validate::isLoadedObject($deliveryAddress) AND ($deliveryAddress->id_customer == $customer->id))
					self::$smarty->assign('delivery', $deliveryAddress);
			}

			/* If invoice address is valid in cart, assign it to Smarty */
			if (isset(self::$cart->id_address_invoice))
			{
				$invoiceAddress = new Address((int)(self::$cart->id_address_invoice));
				if (Validate::isLoadedObject($invoiceAddress) AND ($invoiceAddress->id_customer == $customer->id))
					self::$smarty->assign('invoice', $invoiceAddress);
			}
		}
		if ($oldMessage = Message::getMessageByCartId((int)(self::$cart->id))) {
      // xavi hack
      if(strpos($oldMessage['message'], "EL CLIENTE QUIERE RECIBIR LA FACTURA" ) === false) {
        self::$smarty->assign('wantedbill', '');
      } else {
        self::$smarty->assign('wantedbill', 'checked="checked"');
        $oldMessage['message'] = str_replace("EL CLIENTE QUIERE RECIBIR LA FACTURA\n\n", '', $oldMessage['message']);
      }
      // end xavi
			self::$smarty->assign('oldMessage', $oldMessage['message']);
    }
	}
}

?>
