<?php

class StoresController extends StoresControllerCore
{
	public $php_self = 'stores.php';

	public function preProcess() {
    global $smarty, $cookie;
    $stores_db = Db::getInstance()->ExecuteS('
      SELECT s.*, cl.name country, st.iso_code state, z.name as zone, z.id_zone
      FROM '._DB_PREFIX_.'store s
      LEFT JOIN '._DB_PREFIX_.'country_lang cl ON (cl.id_country = s.id_country)
      LEFT JOIN '._DB_PREFIX_.'state st ON (st.id_state = s.id_state)
      LEFT JOIN '._DB_PREFIX_.'country c ON (c.id_country = s.id_country)
      LEFT JOIN '._DB_PREFIX_.'zone z ON (c.id_zone = z.id_zone)
      WHERE s.active = 1 AND cl.id_lang = '.(int)($cookie->id_lang).'
      ORDER BY zone, country, s.city, s.name');

    $zones = array();
    $countries = array();
    $cities = array();
    $stores = array();
    foreach($stores_db as $store) {
      $zones[$store['id_zone']]['name'] = $store['zone'];
      $zones[$store['id_zone']]['id'] = $store['id_zone'];

      $countries[$store['id_zone']]['zone'] =  $store['id_zone'];
      $countries[$store['id_zone']]['countries'][$store['id_country']]['name'] = $store['country'];
      $countries[$store['id_zone']]['countries'][$store['id_country']]['id'] = $store['id_country'];

      $cities[$store['id_country']]['country'] = $store['id_country'];
      $cities[$store['id_country']]['cities'][$store['city']] = $store['city'];

      $stores[$store['city']]['city'] = $store['city'];
      $stores[$store['city']]['stores'][$store['id_store']] = $store;
    }
		
		$smarty->assign(array('zones' => $zones, 'countries' => $countries, 'cities' => $cities, 'stores' => $stores));
	}

	public function setMedia() {
    parent::setMedia();
    Tools::addJS(_THEME_JS_DIR_.'stores.js');
	}

}
